<template id="client">
  <div class="container mt-5">
    <h2>Cadastro de Clientes</h2>
    <div class="panel-group">
      <div class="panel panel-default">
        <div class="card-header">
          <div class="form-group row">
            <div class="col-md-9">
              <input
                type="text"
                class="form-control"
                name="cpf"
                v-model="stringBusca"
                placeholder="cpf"
                required
              />
            </div>
            <div class="col-md-3">
              <a
                class="btn btn-warning float-right"
                @click="buscar(stringBusca)"
              >
                <i class="fas fa-search"></i>buscar
              </a>
            </div>
            <div class="card-body">
              <form @submit.prevent="salvar">
                <div class="form-group row">
                  <div class="col-lg-12">
                    <input
                      type="text"
                      class="form-control"
                      name="nome"
                      ref="nome"
                      v-model="cliente.nome"
                      placeholder="nome"
                      required
                    />
                  </div>
                </div>
                <div class="form-group row">
                  <div class="col-lg-12">
                    <input
                      type="text"
                      class="form-control"
                      name="endereco"
                      v-model="cliente.endereco"
                      placeholder="Endereço"
                      required
                    />
                  </div>
                </div>
                <div class="form-group row">
                  <div class="col-lg-6">
                    <input
                      type="text"
                      class="form-control"
                      name="email"
                      v-model="cliente.email"
                      placeholder="email"
                      required
                    />
                  </div>

                  <div class="col-lg-6">
                    <input
                      type="text"
                      class="form-control"
                      name="cpf"
                      v-model="cliente.cpf"
                      placeholder="cpf"
                      required
                    />
                  </div>
                </div>
                <div class="form-group row">
                  
                  <div class="col-lg-6">
                    <input
                      type="text"
                      class="form-control"
                      name="valor"
                      v-model="cliente.valor"
                      placeholder="Valor devido"
                      required
                    />
                  </div>
                
                  <div class="col-lg-6">
                    <input
                      type="text"
                      class="form-control"
                      name="telefone"
                      v-model="cliente.telefone"
                      placeholder="telefone"
                      required
                    />
                  </div>
                  </div>
                <div class="form-group row">
                  <!-- <a class="btn btn-primary text-white float-right"  v-show="!tipo"  >
                      <i class="fas fa-sync"></i>Atualizar
                    </a> -->
                  <a
                    type="submit"
                    class="btn btn-success text-white float-right text-white"
                    value="Salvar"
                    @click="salvar()"
                  >
                    <i class="fas fa-plus-circle"></i>salvar
                  </a>
                </div>
              </form>
            </div>
          </div>
        </div>
      </div>
    </div>

    <table class="table table-striped mt-5">
      <thead>
        <tr>
          <th>cpf</th>
          <th>nome</th>
          <th>email</th>
          <th>valor devido</th>
        </tr>
      </thead>

      <tbody>
        <tr v-for="cliente in clientes" v-bind:key="cliente.id">
          <td>{{ cliente.cpf }}</td>
          <td>{{ cliente.nome }}</td>
          <td>{{ cliente.email }}</td>
          <td>{{ cliente.valor }}</td>
          <td>
            <a
              data-toggle="collapse"
              href="'#' + cliente.id"
              class="btn btn-sm btn-warning mx-1"
              @click="editar(cliente.id)"
            >
              <i class="far fa-edit" title="Alterar"></i>
            </a>
            
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</template>

<script>
import axios from "axios";

export default {
  data() {
    return {
      stringBusca: "",
      clientes: null,
      cliente: {
        id: null,
        nome: null,
        email: null,
        cpf: null,
        telefone: null,
        endereco: null,
        senha: null,
        valor: null,
        user_id:null
      },
    };
  },
  methods: {
    listar() {
      axios
        .get(this.$MainURL + "/clientes", {
          headers: {
            Authorization: `Bearer ${localStorage.getItem("token")}`,
          },
        })
        .then((response) => (this.clientes = response.data));
    },
    buscar(cpf) {
      if (!cpf) {
        this.listar();
      } else {
        axios
          .get(this.$MainURL + "/clientes/" + cpf, {
            headers: {
              Authorization: `Bearer ${localStorage.getItem("token")}`,
            },
          })
          .then((response) => (this.clientes = response.data));
      }
    },
    salvar() {
      this.cliente.senha = this.cliente.cpf
      if (this.cliente.id) {
        axios
          .put(
            this.$MainURL + "/clientes/" + this.cliente.user_id,
            this.cliente,
            {
              headers: {
                Authorization: `Bearer ${localStorage.getItem("token")}`,
              },
            }
          )
          // eslint-disable-next-line no-unused-vars
          .then((response) => {
            alert(`Ok, Alterado com sucesso`);
            this.listar();
            this.cliente = {};
          });
      } else {
        
        axios
          .post(this.$MainURL + "/clientes", this.cliente, {
            headers: {
              Authorization: `Bearer ${localStorage.getItem("token")}`,
            },
          })
          .then((response) => {
            alert(`Ok, cadastrado com ID: ${response.data.id}`);
            this.listar();
            this.cliente = {};
          });
      }
    },
    editar(id) {
      axios
        .get(this.$MainURL + "/cliente/" + id, {
          headers: {
            Authorization: `Bearer ${localStorage.getItem("token")}`,
          },
        })
        .then((response) => {
          this.cliente = response.data;
          console.log(this.cliente)
        });
      this.$refs.nome.focus();
    },
    
    sal(id) {
      setTimeout(() => {
        this.cliente.id = id;
        this.axios
          .post(this.$MainURL + "/clientes", this.clientes, {
            headers: {
              Authorization: `Bearer ${localStorage.getItem("token")}`,
            },
          })
          .then(this.GoBack());
      }, 3000);
    },
    GoBack() {
      window.history.length > 1 ? this.$router.go(-1) : this.$router.push("/");
    },
  },
  mounted() {
    this.listar();
  },
};
</script>

<style scoped></style>
